#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef double ld;

typedef pair<ll, ll> ii;
typedef vector<ll> vi;
typedef vector<ii> vii;

#define PB push_back
#define FOR(prom, a, b) for ( ll prom = (a); prom < (ll)(b); ++prom )
#define F(a) FOR(i,0,a)
#define FF(a) FOR(j,0,a)

#define EPS (1e-10)

struct Pt{
	ll x,y;
};

ll N;
vector<vi> buildGraph(vector<Pt> &a){
	vector<vi> g(N);
	F(N)FOR(j,i+1,N){
		ll x=a[i].x-a[j].x;
		ll y=a[i].y-a[j].y;
		ll d=x*x+y*y;
		if(d == 1){
			g[i].PB(j);
			g[j].PB(i);
		}
	}
	return g;
}

int main () {
	ios::sync_with_stdio(false);
	while(cin>>N){
		vector<Pt> a(N);
		F(N)cin>>a[i].x>>a[i].y;
		vector<vi> g=buildGraph(a);
		F(N){
			cout<<i<<": ";
			for(auto n:g[i]){
				cout<<n<<' ';
			}
			cout<<endl;
		}
		
		ll res=0;
		queue<ll> q;
		vi c(N,2);
		F(N)if(c[i]==2){
			c[i]=0;
			ll ww[2];F(2)ww[i]=0;
			q.push(i);
			while(!q.empty()){
				ll e=q.front();q.pop();
				for(ll n:g[e]){
					if(c[n] == 2){
						c[n]=1-c[e];
						++ww[c[n]];
					}
				}
			}
			res+=max(ww[0],ww[1]);
		}
		cout<<res<<endl;
	}
	
	return 0;
}
